using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.Runtime.Remoting;

namespace CallBackDAO
{
	public class SummaryForm : System.Windows.Forms.Form
	{
        private System.Windows.Forms.Label label1;
        private System.Windows.Forms.Label label2;
        private System.Windows.Forms.Label label3;
        private System.Windows.Forms.Label label4;
        private System.Windows.Forms.Label label5;
        private System.Windows.Forms.Label label6;
        private System.Windows.Forms.Label label7;
        private System.Windows.Forms.Button button1;
        private System.Windows.Forms.NumericUpDown ViewDropDown;
        private System.Windows.Forms.Label OrderLabel;
        private System.Windows.Forms.Label AccountLabel;
        private System.Windows.Forms.Label TickerLabel;
        private System.Windows.Forms.Label QtyLabel;
        private System.Windows.Forms.Label PriceLabel;
        private System.Windows.Forms.Label TotalLabel;
        private System.Windows.Forms.Label label14;
        private System.Windows.Forms.Label TypeLabel;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

        // These need to be global for the lifetime of the form
        private StockRecordDAO dao = new StockRecordDAO();
        private ArrayList allRecords = new ArrayList();

		public SummaryForm()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
            this.label1 = new System.Windows.Forms.Label();
            this.label2 = new System.Windows.Forms.Label();
            this.ViewDropDown = new System.Windows.Forms.NumericUpDown();
            this.label3 = new System.Windows.Forms.Label();
            this.label4 = new System.Windows.Forms.Label();
            this.label5 = new System.Windows.Forms.Label();
            this.label6 = new System.Windows.Forms.Label();
            this.label7 = new System.Windows.Forms.Label();
            this.OrderLabel = new System.Windows.Forms.Label();
            this.AccountLabel = new System.Windows.Forms.Label();
            this.TickerLabel = new System.Windows.Forms.Label();
            this.QtyLabel = new System.Windows.Forms.Label();
            this.PriceLabel = new System.Windows.Forms.Label();
            this.button1 = new System.Windows.Forms.Button();
            this.TotalLabel = new System.Windows.Forms.Label();
            this.label14 = new System.Windows.Forms.Label();
            this.TypeLabel = new System.Windows.Forms.Label();
            ((System.ComponentModel.ISupportInitialize)(this.ViewDropDown)).BeginInit();
            this.SuspendLayout();
            // 
            // label1
            // 
            this.label1.Location = new System.Drawing.Point(8, 16);
            this.label1.Name = "label1";
            this.label1.Size = new System.Drawing.Size(112, 23);
            this.label1.TabIndex = 0;
            this.label1.Text = "Number of records:";
            // 
            // label2
            // 
            this.label2.Location = new System.Drawing.Point(8, 44);
            this.label2.Name = "label2";
            this.label2.TabIndex = 1;
            this.label2.Text = "View Record No.:";
            // 
            // ViewDropDown
            // 
            this.ViewDropDown.Location = new System.Drawing.Point(120, 40);
            this.ViewDropDown.Name = "ViewDropDown";
            this.ViewDropDown.Size = new System.Drawing.Size(56, 20);
            this.ViewDropDown.TabIndex = 2;
            this.ViewDropDown.ValueChanged += new System.EventHandler(this.ViewDropDown_ValueChanged);
            // 
            // label3
            // 
            this.label3.Location = new System.Drawing.Point(8, 88);
            this.label3.Name = "label3";
            this.label3.TabIndex = 3;
            this.label3.Text = "Order ID:";
            // 
            // label4
            // 
            this.label4.Location = new System.Drawing.Point(8, 144);
            this.label4.Name = "label4";
            this.label4.TabIndex = 4;
            this.label4.Text = "Account ID:";
            // 
            // label5
            // 
            this.label5.Location = new System.Drawing.Point(8, 168);
            this.label5.Name = "label5";
            this.label5.TabIndex = 5;
            this.label5.Text = "Ticker:";
            // 
            // label6
            // 
            this.label6.Location = new System.Drawing.Point(8, 192);
            this.label6.Name = "label6";
            this.label6.TabIndex = 6;
            this.label6.Text = "Qty:";
            // 
            // label7
            // 
            this.label7.Location = new System.Drawing.Point(8, 216);
            this.label7.Name = "label7";
            this.label7.TabIndex = 7;
            this.label7.Text = "Price:";
            // 
            // OrderLabel
            // 
            this.OrderLabel.Location = new System.Drawing.Point(120, 88);
            this.OrderLabel.Name = "OrderLabel";
            this.OrderLabel.TabIndex = 8;
            this.OrderLabel.Text = "0000";
            // 
            // AccountLabel
            // 
            this.AccountLabel.Location = new System.Drawing.Point(120, 144);
            this.AccountLabel.Name = "AccountLabel";
            this.AccountLabel.TabIndex = 9;
            this.AccountLabel.Text = "00000";
            // 
            // TickerLabel
            // 
            this.TickerLabel.Location = new System.Drawing.Point(120, 168);
            this.TickerLabel.Name = "TickerLabel";
            this.TickerLabel.TabIndex = 10;
            this.TickerLabel.Text = "XXXX";
            // 
            // QtyLabel
            // 
            this.QtyLabel.Location = new System.Drawing.Point(120, 192);
            this.QtyLabel.Name = "QtyLabel";
            this.QtyLabel.TabIndex = 11;
            this.QtyLabel.Text = "XXXX";
            // 
            // PriceLabel
            // 
            this.PriceLabel.Location = new System.Drawing.Point(120, 216);
            this.PriceLabel.Name = "PriceLabel";
            this.PriceLabel.TabIndex = 12;
            this.PriceLabel.Text = "XXXX";
            // 
            // button1
            // 
            this.button1.Location = new System.Drawing.Point(184, 256);
            this.button1.Name = "button1";
            this.button1.TabIndex = 13;
            this.button1.Text = "Close";
            this.button1.Click += new System.EventHandler(this.button1_Click);
            // 
            // TotalLabel
            // 
            this.TotalLabel.Location = new System.Drawing.Point(120, 16);
            this.TotalLabel.Name = "TotalLabel";
            this.TotalLabel.TabIndex = 14;
            this.TotalLabel.Text = "0000";
            // 
            // label14
            // 
            this.label14.Location = new System.Drawing.Point(8, 120);
            this.label14.Name = "label14";
            this.label14.TabIndex = 15;
            this.label14.Text = "Type:";
            // 
            // TypeLabel
            // 
            this.TypeLabel.Location = new System.Drawing.Point(120, 120);
            this.TypeLabel.Name = "TypeLabel";
            this.TypeLabel.TabIndex = 16;
            this.TypeLabel.Text = "Unknown";
            // 
            // Form1
            // 
            this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
            this.ClientSize = new System.Drawing.Size(272, 293);
            this.Controls.Add(this.TypeLabel);
            this.Controls.Add(this.label14);
            this.Controls.Add(this.TotalLabel);
            this.Controls.Add(this.button1);
            this.Controls.Add(this.PriceLabel);
            this.Controls.Add(this.QtyLabel);
            this.Controls.Add(this.TickerLabel);
            this.Controls.Add(this.AccountLabel);
            this.Controls.Add(this.OrderLabel);
            this.Controls.Add(this.label7);
            this.Controls.Add(this.label6);
            this.Controls.Add(this.label5);
            this.Controls.Add(this.label4);
            this.Controls.Add(this.label3);
            this.Controls.Add(this.ViewDropDown);
            this.Controls.Add(this.label2);
            this.Controls.Add(this.label1);
            this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedSingle;
            this.Name = "Form1";
            this.Text = "Order Table Summary";
            this.Load += new System.EventHandler(this.Form1_Load);
            ((System.ComponentModel.ISupportInitialize)(this.ViewDropDown)).EndInit();
            this.ResumeLayout(false);

        }
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new SummaryForm());
		}

        private void button1_Click(object sender, System.EventArgs e)
        {
            Close();
        }

        private void Form1_Load(object sender, System.EventArgs e)
        {
            // Create the event handler that will notify when a record has been updated
            dao.Updated += new UpdateEventHandler(dao_Updated);

            // Display all the records in the form
            DisplayAllRecords();
        }

        private void DisplayAllRecords()
        {
            // Get all records from the DAO
            allRecords = dao.GetAllStockRecords();

            // Display summary
            TotalLabel.Text = allRecords.Count.ToString();
            ViewDropDown.Minimum = 1;
            ViewDropDown.Maximum = allRecords.Count;

            // Display first record
            DisplayStockRecord((StockRecord)allRecords[0]);
        }

        private void DisplayStockRecord(StockRecord record)
        {
            // Populate the form based on a record being selected
            OrderLabel.Text = record.ID.ToString();
            TypeLabel.Text = (record.Type == "P" ? "Purchase" : "Sale");
            AccountLabel.Text = record.AccountID.ToString();
            TickerLabel.Text = record.Ticker;
            QtyLabel.Text = record.Qty.ToString();
            PriceLabel.Text = record.Price.ToString();
        }

        private void ViewDropDown_ValueChanged(object sender, System.EventArgs e)
        {
            // Update the current stock record when one is selected in the drop down
            DisplayStockRecord((StockRecord)allRecords[((int)ViewDropDown.Value)-1]);
        }

        // Method that gets triggered when the Java client notifies of an update
        private void dao_Updated(Object o, EventArgs e)
        {
            // Uncomment this message line to be notified of changes
            // MessageBox.Show("The Java client has added a record to the order table.  Click on OK to refresh.");

            DisplayAllRecords();  //refresh the data displayed on the form
        }

	}
}
