import java.util.ArrayList;

public class Client
{
	public static void main(String[] args)
	{
        
        try
        {
            StockRecordDAO dao = new StockRecordDAO();

            StockRecord record  = dao.getStockRecord(1002);
            System.out.println("Reading a single record with ID=1002:  "+record.Ticker);
            
            ArrayList records = dao.getStockRecords(38084);            
            System.out.println("There are "+records.size()+" records with ID = 38084");
            
            System.out.println("Adding a record...");
            StockRecord newRecord = new StockRecord(0,"S",38084,"WOOD",250,14.60);
            dao.addStockRecord(newRecord);
            
        }
        catch (StockRecordDAOException srdao)
        {
            srdao.printStackTrace();
        }
	}
}
