package CallBackDAO;

import com.intrinsyc.janet.*;
import com.intrinsyc.janet.remoting.ObjRef;

public class NotificationRemoting extends RemoteProxy {


  /**
   * Constructor NotificationRemoting
   *
   * @param objRef
   *
   * throws RemoteException
   */
  public NotificationRemoting(ObjRef objRef) throws RemoteException {
    super(objRef);
  }

  // Void .ctor()

  /**
   * Constructor NotificationRemoting
   *
   * @throws RemoteException
   */
  public  NotificationRemoting() throws RemoteException  {
    super("CallBackDAO.NotificationRemoting", "CallBackDAO",
      new int[] {},
      new Object[] {},
      new String[] {});
  }

  // Void .ctor()

  /**
   * Constructor NotificationRemoting
   *
   * @param URI
   * @param format
   * @param clientActivated
   * @throws RemoteException
   */
  public  NotificationRemoting(String URI, String format, 
      boolean clientActivated) throws RemoteException  {
    super("CallBackDAO.NotificationRemoting", "CallBackDAO",
      URI, format, clientActivated,
      new int[] {},
      new Object[] {},
      new String[] {});
  }

  // Void Update()

  /**
   * Method Update
   *
   * @throws RemoteException
   */
  public void Update() throws RemoteException  {
    invokeMethod("Update",
      new int[] {VOID | RETURN},
      new Object[] {null},
      new String[] {"System.Void"});

  }


  // for internal use only

  /**
   * Constructor NotificationRemoting
   *
   * @param className
   * @param assembly
   * @param parameterTypes
   * @param parameterValues
   * @param parameterTypeNames
   *
   * @throws RemoteException
   *
   */
  protected NotificationRemoting(String className, String assembly,
        int[] parameterTypes, Object[] parameterValues,
        String[] parameterTypeNames) throws RemoteException {
    super(className, assembly, 
      parameterTypes, parameterValues, parameterTypeNames);
  }

  // for internal use only

  /**
   * Constructor NotificationRemoting
   *
   * @param className
   * @param assembly
   * @param URI
   * @param format
   * @param clientActivated
   * @param parameterTypes
   * @param parameterValues
   * @param parameterTypeNames
   *
   * @throws RemoteException
   */
  protected NotificationRemoting(String className, String assembly,
        String URI, String format, boolean clientActivated,
        int[] parameterTypes, Object[] parameterValues,
        String[] parameterTypeNames) throws RemoteException {
    super(className, assembly, URI, format, clientActivated,
      parameterTypes, parameterValues, parameterTypeNames);
  }

  public static final java.lang.String __janetAssemblyName = 
    "CallBackDAO, Version=1.0.1164.21760, Culture=neutral, PublicKeyToken=null";
  public static final java.lang.String __janetClassName = 
    "CallBackDAO.NotificationRemoting";
}
